// Lemmings - Windows CE port by Jacco Bikker, a.k.a.
// "The Phantom"  -   Intended as a demonstration of
//   EasyCE - Visit http://www.cewarez.com/coding

// --------------------------------------------------
#ifndef LEMMING_I
#define LEMMING_I

#ifdef _WIN32_WCE
#define SCREEN_TITLE	L"Program Files\\EasyCE\\images\\title_pal.tga"
#define LEVEL1			L"Program Files\\EasyCE\\images\\level4.tga"
#define LEVEL2			L"Program Files\\EasyCE\\images\\level1b.tga"
#define LEVEL3			L"Program Files\\EasyCE\\images\\level5.tga"
#define LEVEL4			L"Program Files\\EasyCE\\images\\level3.tga"
#define SPRITESET		L"Program Files\\EasyCE\\images\\lemanim.tga"
#define BUTTONS			L"Program Files\\EasyCE\\images\\buttons.tga"
#define BBUTTONS		L"Program Files\\EasyCE\\images\\bbuttons.tga"
#define TING_WAV		"Program Files\\EasyCE\\sounds\\ting.wav"
#define OHNO_WAV		"Program Files\\EasyCE\\sounds\\ohno.wav"
#define EXPLODE_WAV		"Program Files\\EasyCE\\sounds\\explode.wav"
#define SPLAT_WAV		"Program Files\\EasyCE\\sounds\\splat.wav"
#define OING_WAV		"Program Files\\EasyCE\\sounds\\oing.wav"
#define DOOR_WAV		"Program Files\\EasyCE\\sounds\\door.wav"
#define LETSGO_WAV		"Program Files\\EasyCE\\sounds\\letsgo.wav"
#define CHANGEOP_WAV	"Program Files\\EasyCE\\sounds\\changeop.wav"
#define BGM1			"Program Files\\EasyCE\\sounds\\lem2-pol.mod"
#define BGM2			"Program Files\\EasyCE\\sounds\\lemmus0.mod"
#define BGMTITLE		"Program Files\\EasyCE\\sounds\\ohnom0.mod"
#else
#define SCREEN_TITLE	"images/title_pal.tga"
#define LEVEL1			"images/level4.tga"
#define LEVEL2			"images/level1b.tga"
#define LEVEL3			"images/level5.tga"
#define LEVEL4			"images/level3.tga"
#define SPRITESET		"images/lemanim.tga"
#define BUTTONS			"images/buttons.tga"
#define BBUTTONS		"images/bbuttons.tga"
#define TING_WAV		"sounds/ting.wav"
#define OHNO_WAV		"sounds/ohno.wav"
#define EXPLODE_WAV		"sounds/explode.wav"
#define SPLAT_WAV		"sounds/splat.wav"
#define OING_WAV		"sounds/oing.wav"
#define DOOR_WAV		"sounds/door.wav"
#define LETSGO_WAV		"sounds/letsgo.wav"
#define CHANGEOP_WAV	"sounds/changeop.wav"
#define BGM1			"sounds/lem2-pol.mod"
#define BGM2			"sounds/lemmus0.mod"
#define BGMTITLE		"sounds/ohnom0.mod"
#endif

class LAnim
{
public:
	LAnim();
	~LAnim();
	void setfpos( int i, int x, int y ) { m_Fx[i] = x; m_Fy[i] = y; }
	void setsize( int x, int y ) { m_Fszx = x; m_Fszy = y; }
	void setframes( int n ) { m_Frames = n; }
	int getframes( void ) { return m_Frames; }
	void update( int x, int y, int frame );
private:
	int m_Frames;
	int m_Fx[32], m_Fy[32];
	int m_Fszx, m_Fszy;
public:
	static unsigned short* s_Frames;
};

class Lemming
{
public:
	Lemming();
	~Lemming();
	void setpos( int x, int y ) { m_X = x; m_Y = y; }
	void setanim( LAnim* a ) { m_Anim = a; }
	LAnim* getanim( void ) { return m_Anim; }
	void update( void );
	void draw( void );
	int getxpos( void ) { return m_X; }
	int getypos( void ) { return m_Y; }
	int getframe( void ) { return m_Frame; }
	void setframe( int i ) { m_Frame = i; }
	void setcounter( int i ) { m_Counter = i; }
	int getcounter( void ) { return m_Counter; }
	void isfloater( void ) { m_Floater = true; }
	void isclimber( void ) { m_Climber = true; }
	void isbomb( void ) { if (!m_Bomb) { m_Bomb = true; m_BCount = 6 * 8; } }
	bool getbomb( void ) { return m_Bomb; }
	bool getfloat( void ) { return m_Floater; }
private:
	int m_X, m_Y;
	int m_Counter, m_BCount, m_Height;
	int m_Frame;
	bool m_Floater, m_Climber, m_Bomb;
	LAnim* m_Anim;
};

#endif

// --------------------------------------------------
// EOF