// Phantom's PocketPC Building Blocks (c) 2000/2001
// Basic types, defines and stuff like that
// ------------------------------------------------

#ifndef I_PHANTOM
#define I_PHANTOM

// Pixels
#define PIXEL unsigned short			// 16bit pixel
#define IPIXEL unsigned char			// palettized pixel

// Pixel operations
#define SHFTMASK ((15<<11)+(31<<5)+15)	// for single shifts
#define DSHFTMASK ((7<<11)+(15<<5)+7)	// for double shifts
#define TSHFTMASK ((3<<11)+(7<<5)+3)	// for triple shifts
#ifndef REDMASK
#define REDMASK (31 << 11)
#define GREENMASK (63 << 5)
#define BLUEMASK (31)
#endif

// Fixed point defines
#define FPP 10
#define FP_ONE (1<<FPP)
#define FPMUL(x,y) (((x)*(y))>>FPP)
#define FPDIV(x,y) (((x)<<FPP)/(y))
#define FP(x) ((int)((x)*FP_ONE+0.5f))
#define IFP(x) ((x)<<FPP)

// Basic math stuff
#define PI 3.14159265359

// WinCE / Windows compatibility
#if _WIN32_WCE==300
typedef unsigned short ACHAR;
#else
typedef char ACHAR;
#endif

inline PIXEL addblend( PIXEL c1, PIXEL c2 )
{
	int r = (c1 & (31 << 11)) + (c2 & (31 << 11));
	int g = (c1 & (63 << 5)) + (c2 & (63 << 5));
	int b = (c1 & 31) + (c2 & 31);
	if (r > (31 << 11)) r = 31 << 11;
	if (g > (63 << 5)) g = 63 << 5;
	if (b > 31) b = 31;
	return (PIXEL)(r + g + b);
}

inline PIXEL scalecolor( PIXEL c1, int mul )
{
	int r = (c1 & REDMASK) >> 11;
	int g = (c1 & GREENMASK) >> 5;
	int b = (c1 & BLUEMASK);
	r = (r * mul) >> 8;
	g = (g * mul) >> 8;
	b = (b * mul) >> 8;
	return ((PIXEL)((r << 11) + (g << 5) + b));
}

#endif

// ------------------------------------------------
// EOF