// Generic tga class - February 2001 -  The Phantom
// ------------------------------------------------
 
#ifndef I_TGAFILE
#define I_TGAFILE

#include "phantom.h"

class ATgaFile
{
public:
	ATgaFile();
	~ATgaFile();
	static bool load( ACHAR* file, int w, int h, IPIXEL* dest, PIXEL* pal = 0 );
	static bool load( ACHAR* file, int w, int h, PIXEL* dest );
	static void ATgaFile::parseheader( unsigned char* a_Header );
private:
	static int s_IDLen;		// Length of Image Descriptor field
	static int s_CMapType;	// Color map type
	static int s_ImgType;	// Image type; 1 = indexed, 2 = RGB, others are compressed
	static int s_CMapOrig;	// Index of first color map entry
	static int s_CMapLen;	// Number of colors in color map
	static int s_CMapSize;	// Size of single color in color map (in bits)
	static int s_XPos;		// X-Coord of lower left corner
	static int s_YPos;		// Y-Coord of lower left corner
	static int s_Width;		// Width of the image
	static int s_Height;	// Height of the image
	static int s_PixSize;	// Bits per pixel in image map
};

#endif

// ------------------------------------------------
// EOF